//	PhotoFrame NOKIA3300-LCD(S1D15G10)
//	V-USB AVR-HID
//	wt]xH쎺	http://jsdiy.web.fc2.com

/*
y|[gΉz	ATtiny2313	x:݂Ȃ(PA2RESET) -:
bit		7	6	5	4	3	2	1	0
portA	x	x	x	x	x	x	Xtl	Xtl		NX^
portB	SCL	SI	-	CS	-	-	-	-		LCD
portD	x	-	-	D-	D+	-	-	-		V-USB

yATtiny2313z
|-BBBBBBBBD|
|V765432106|
>          |
|201102345G|
|ADDAADDDD-|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100100(64), Hi:11011111(DF)
[vusb-20120109/examples/hid-data/firmware/Makefile]Q
Low: 11101111 (EF)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PD2ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11011 (DB)
     |||||||+-- RSTDISBL (RESETs 1:L, 0:(PA2))
     ||||+++-- BODLEVEL[2:0] (111:Off, 110:1.8, 101:2.7, 100:4.3)
     |||+-- WDTON (WDT 0:펞ON, 1:ʏ)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- EESAVE (EEPROM 1:, 0:ێ)
     +-- DWEN (On-ChipfobO 1:, 0:L)

Ext: -------1 (FF)
            +-- SPMEN (SPM 1:, 0:L)

yrhz
Atmel AVR Studio 5 (Version: 5.1.208)	œKIvV: -Os
AVRGCC Version: 3.3.1.27
NX^Uq: 12MHz

yXVz
2012/05/29	v1.00	Program:    1748 bytes (85.4% Full)
					Data:         55 bytes (43.0% Full)
*/

#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#include <avr/pgmspace.h>
#include "usbdrv.h"

/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */

PROGMEM char usbHidReportDescriptor[USB_CFG_HID_REPORT_DESCRIPTOR_LENGTH] =
{
    0x06, 0x00, 0xff,              // USAGE_PAGE (Vendor Defined Page 1)
    0x09, 0x01,                    // USAGE (Vendor Usage 1)
    0xa1, 0x01,                    // COLLECTION (Application)
    0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
    0x26, 0xff, 0x00,              //   LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //   REPORT_SIZE (8) bit
	
    0x09, 0x00,                    //   USAGE (Undefined)
    0x95, 0x08,                    //   REPORT_COUNT (8)
    0xb1, 0x02,                    //   FEATURE (Data,Var,Abs)
	
	0xc0                           // END_COLLECTION
};

/* ------------------------------------------------------------------------- */

#define CMD_BUF_SIZE	8
#define FEATURE_REPORT_SIZE	CMD_BUF_SIZE
static uint8_t	cmdBuf[CMD_BUF_SIZE];
static uint8_t	bufIndex;
static uint8_t	bytesRemaining;

enum CmdIdx
{
	//cmdBuf[0:Cmd][1:value][2:Cmd][3:value][4:Cmd][5:value][6:Cmd][7:value]
	ICmd = 0,	//bit:7=flag, bit:6-0=count
	IVal
};

#define FLAG_CMD	0b10000000
#define MASK_COUNT	0b01111111

//LCD̒萔`
#define USI_USCK	(1 << PB7)
#define USI_DO		(1 << PB6)
#define USI_DI		(1 << PB5)
#define LCD_CS		(1 << PB4)
#define LCD_SI		USI_DO
#define LCD_SCL		USI_USCK
#define LCD_CMD_BV	(0 << 7)	//When entering commands: SI = LOW at the rising edge of the 1st SCL.
#define LCD_DATA_BV	(1 << 7)	//When entering data (parameters): SI = HIGH at the rising edge of the 1st SCL.
#define lcdSetLo(bv)	{ PORTB &= ~(bv); }
#define lcdSetHi(bv)	{ PORTB |= (bv); }

//3^NbN̗ŃVtg{o͂^NbN̓\tgIɐ
#define USICR_CLKSRC_SELECT	((0 << USIWM1) | (1 << USIWM0) | (1 << USICS1) | (1 << USICS0) | (1 << USICLK))
#define USI_TOGGLE_CLKPIN	(USICR_CLKSRC_SELECT | (1 << USITC))

//LCD𑀍삷
//	bvType:		MeR}hAf[^ilMSBɃZbgĂj
//		byteValue:	R}hA܂́Af[^̎l
//E̊֐SCL=HȉԂŌĂяoƁB
static void	lcdCtrl(uint8_t bvType, uint8_t byteValue)
{
	uint8_t i;
	
	lcdSetLo(LCD_CS);
	
	//R}h^f[^̋1bit𑗏o
	USIDR = bvType;
	USICR = USI_TOGGLE_CLKPIN;	//SCL=Lo
	USICR = USI_TOGGLE_CLKPIN;	//SCL=Hi
	
	//R}h^f[^̎l8bit𑗏o
	USIDR = byteValue;
	for (i = 0; i < 8; i++)
	{
		USICR = USI_TOGGLE_CLKPIN;	//SCL=Lo
		USICR = USI_TOGGLE_CLKPIN;	//SCL=Hi
	}
	
	lcdSetHi(LCD_CS);
}

/* ------------------------------------------------------------------------- */

uchar   usbFunctionWrite(uchar *data, uchar len)
{
	uint8_t i, bidx, count, val;
	
	if(bytesRemaining == 0) return 1;	//end of transfer
    if(len > bytesRemaining) len = bytesRemaining;
	
	for (i = 0; i < len; i++)
		cmdBuf[bufIndex + i] = data[i];
    
	bufIndex += len;
    bytesRemaining -= len;
	if (0 < bytesRemaining) return 0;	//return FALSE (data write continue)
	
	for (bidx = 0; bidx < CMD_BUF_SIZE; bidx += 2)
	{
		count = (cmdBuf[bidx + ICmd] & MASK_COUNT);
		if (count == 0) break;
		val = cmdBuf[bidx + IVal];
		
		if (cmdBuf[bidx + ICmd] & FLAG_CMD)
		{
			lcdCtrl(LCD_CMD_BV, val);
		}
		else
		{
			for (i = 0; i < count; i++)
				lcdCtrl(LCD_DATA_BV, val);
		}
	}
	
	return 1;	//return TRUE if this was the last chunk
}

/* ------------------------------------------------------------------------- */

usbMsgLen_t usbFunctionSetup(uchar data[8])
{
	usbRequest_t *rq = (void *)data;
	
	//HID class request
	//rq->wValue: ReportType (highbyte:[1]), ReportID (lowbyte:[0])
    if((rq->bmRequestType & USBRQ_TYPE_MASK) == USBRQ_TYPE_CLASS)
	{
		if(rq->bRequest == USBRQ_HID_SET_REPORT)
		{
            bufIndex = 0;
			bytesRemaining = FEATURE_REPORT_SIZE;
			return USB_NO_MSG;
		}
    }
	else
	{
        //ignore vendor type requests, we don't use any
    }
    return 0;
}

/* ------------------------------------------------------------------------- */

int main(void)
{
	uint8_t	i;
	
    wdt_enable(WDTO_1S);
	usbInit();
	
	//enforce re-enumeration, do this while interrupts are disabled
	//fake USB disconnect for > 250 ms
	usbDeviceDisconnect();
	i = 0;
	while (--i)
	{
		wdt_reset();
		_delay_ms(1);
	}
	usbDeviceConnect();
	
	//LCD|[g
	DDRB = LCD_CS | LCD_SCL | LCD_SI;
	lcdSetHi(LCD_CS | LCD_SCL);
	
	sei();
	while (1)
	{
		wdt_reset();
		usbPoll();
    }
	
    return 0;
}
